title | description | keywords | ||||||||
---|---|---|---|---|---|---|---|---|---|---|
160. 相交链表 |
LeetCode 160. 相交链表题解,Intersection of Two Linked Lists,包含解题思路、复杂度分析以及完整的 JavaScript 代码实现。 |
|
🟢 Easy 🔖 哈希表
链表
双指针
🔗 力扣
LeetCode
Given the heads of two singly linked-lists headA
and headB
, return the
node at which the two lists intersect. If the two linked lists have no
intersection at all, return null
.
For example, the following two linked lists begin to intersect at node c1
:
The test cases are generated such that there are no cycles anywhere in the entire linked structure.
Note that the linked lists must retain their original structure after the function returns.
Custom Judge:
The inputs to the judge are given as follows (your program is not given these inputs):
intersectVal
- The value of the node where the intersection occurs. This is0
if there is no intersected node.listA
- The first linked list.listB
- The second linked list.skipA
- The number of nodes to skip ahead inlistA
(starting from the head) to get to the intersected node.skipB
- The number of nodes to skip ahead inlistB
(starting from the head) to get to the intersected node.
The judge will then create the linked structure based on these inputs and pass
the two heads, headA
and headB
to your program. If you correctly return
the intersected node, then your solution will be accepted.
Example 1:
Input: intersectVal = 8, listA = [4,1,8,4,5], listB = [5,6,1,8,4,5], skipA = 2, skipB = 3
Output: Intersected at '8'
Explanation: The intersected node's value is 8 (note that this must not be 0 if the two lists intersect).
From the head of A, it reads as [4,1,8,4,5]. From the head of B, it reads as [5,6,1,8,4,5]. There are 2 nodes before the intersected node in A; There are 3 nodes before the intersected node in B.
- Note that the intersected node's value is not 1 because the nodes with value 1 in A and B (2nd node in A and 3rd node in B) are different node references. In other words, they point to two different locations in memory, while the nodes with value 8 in A and B (3rd node in A and 4th node in B) point to the same location in memory.
Example 2:
Input: intersectVal = 2, listA = [1,9,1,2,4], listB = [3,2,4], skipA = 3, skipB = 1
Output: Intersected at '2'
Explanation: The intersected node's value is 2 (note that this must not be 0 if the two lists intersect).
From the head of A, it reads as [1,9,1,2,4]. From the head of B, it reads as [3,2,4]. There are 3 nodes before the intersected node in A; There are 1 node before the intersected node in B.
Example 3:
Input: intersectVal = 0, listA = [2,6,4], listB = [1,5], skipA = 3, skipB = 2
Output: No intersection
Explanation: From the head of A, it reads as [2,6,4]. From the head of B, it reads as [1,5]. Since the two lists do not intersect, intersectVal must be 0, while skipA and skipB can be arbitrary values.
Explanation: The two lists do not intersect, so return null.
Constraints:
- The number of nodes of
listA
is in them
. - The number of nodes of
listB
is in then
. 1 <= m, n <= 3 * 10^4
1 <= Node.val <= 10^5
0 <= skipA < m
0 <= skipB < n
intersectVal
is0
iflistA
andlistB
do not intersect.intersectVal == listA[skipA] == listB[skipB]
iflistA
andlistB
intersect.
Follow up: Could you write a solution that runs in O(m + n)
time and use
only O(1)
memory?
给你两个单链表的头节点 headA
和 headB
,请你找出并返回两个单链表相交的起始节点。如果两个链表不存在相交节点,返回 null
。
题目数据 保证 整个链式结构中不存在环。
注意,函数返回结果后,链表必须 保持其原始结构 。
这题难点在于,由于两条链表的长度可能不同,两条链表之间的节点无法对应。
可以使用双指针,用两个指针 p1
和 p2
分别在两条链表上前进,可以让 p1
遍历完链表 A 之后开始遍历链表 B,让 p2
遍历完链表 B 之后开始遍历链表 A,这样相当于「逻辑上」两条链表接在了一起,这样就可以让 p1
和 p2
同时进入公共部分,也就是同时到达相交节点。
- 时间复杂度:
O(lenA + lenB)
- 空间复杂度:
O(1)
另一种思路,先计算两个链表的长度差,记为 diff
。如果 lenA > lenB
,则将 headA
向后移动 diff
步,使得两个链表剩余的长度相等;如果 lenB > lenA
,则将 headB
向后移动 diff
步,使得两个链表剩余的长度相等。
然后,同时移动 headA
和 headB
,直到找到相交的节点 C 或者走到链表的末尾。如果找到相交的节点 C,则返回该节点;如果走到链表的末尾,则说明两个链表不相交,返回 null
。
- 时间复杂度:
O(lenA + lenB)
- 空间复杂度:
O(1)
::: code-tabs
@tab 双指针
/**
* @param {ListNode} headA
* @param {ListNode} headB
* @return {ListNode}
*/
var getIntersectionNode = function (headA, headB) {
let p1 = headA;
let p2 = headB;
while (p1 !== p2) {
if (p1 == null) {
p1 = headB;
} else {
p1 = p1.next;
}
if (p2 == null) {
p2 = headA;
} else {
p2 = p2.next;
}
}
return p1;
};
@tab 双指针
/**
* Definition for singly-linked list.
* function ListNode(val) {
* this.val = val;
* this.next = null;
* }
*/
/**
* @param {ListNode} headA
* @param {ListNode} headB
* @return {ListNode}
*/
var getIntersectionNode = function (headA, headB) {
const getLength = (head) => {
let len = 0;
while (head !== null) {
head = head.next;
len++;
}
return len;
};
const lenA = getLength(headA);
const lenB = getLength(headB);
let p1 = headA;
let p2 = headB;
if (lenA > lenB) {
for (let i = 0; i < lenA - lenB; i++) {
p1 = p1.next;
}
} else {
for (let i = 0; i < lenB - lenA; i++) {
p2 = p2.next;
}
}
while (p1 !== p2) {
p1 = p1.next;
p2 = p2.next;
}
return p1;
};
:::
题号 | 标题 | 题解 | 标签 | 难度 | 力扣 |
---|---|---|---|---|---|
599 | 两个列表的最小索引总和 | [✓] | 数组 哈希表 字符串 |
🟢 | 🀄️ 🔗 |